var Outtake = function()
{
	var outtake = {};
	var debug = 0;
	
	var subtypeRNA = null;
	var subtypeDNA = null;
	
	var sourceList;
	var sourceListIsValid = false;
	var nameIsValid = false;
	var targetAmountIsValid = false;
	var targetVolumeIsValid = false;
	
	// Page initialization
	outtake.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', outtake.validateStep1);
		Buttons.addClickHandler('sourceList.select', outtake.selectSourceList);
		Events.addEventHandler('sourceList', 'base-selected', outtake.sourceListSelected);
		Events.addEventHandler('outtakeName', 'blur', outtake.nameOnChange);
		Events.addEventHandler('targetAmount', 'keypress', Events.numberOnly);
		Events.addEventHandler('targetAmount', 'blur', outtake.targetAmountOnChange);
		Events.addEventHandler('targetVolume', 'keypress', Events.numberOnly);
		Events.addEventHandler('targetVolume', 'blur', outtake.targetVolumeOnChange);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', outtake.submit);

		Doc.show('step-1');
		Doc.show('goregister');
		Doc.element('outtakeName').focus();
	}

	outtake.selectSourceList = function()
	{
		var frm = document.forms['reggie'];
		
		if (subtypeDNA == null) subtypeDNA = Reggie.getSubtypeInfo('DNA');
		if (subtypeRNA == null) subtypeRNA = Reggie.getSubtypeInfo('RNA');
		
		var url = '&resetTemporary=1';
		if (frm.sourceList.length > 1)
		{
			var id = Math.abs(parseInt(frm.sourceList[1].value));				
			url += '&item_id='+id;
		}
		url += '&tmpfilter:INT:memberType='+Data.int('page-data', 'extract-type');
		url += '&tmpfilter:INT:itemSubtype='+subtypeDNA.id+'|'+subtypeRNA.id;
		Dialogs.selectItem('ITEMLIST', 'sourceList', 0, url);
	}
	
	outtake.sourceListSelected = function(event)
	{
		Wizard.setNoConfirmOnFirstStep(false);
		var frm = document.forms['reggie'];
		
		Doc.element('listType').innerHTML = '';
		Doc.element('listSize').innerHTML = '';
		Doc.element('listRemainingQuantity').innerHTML = '';
		Doc.element('listNdConc').innerHTML = '';

		var list = event.detail;
		frm.sourceList[0] = new Option(list.name, list.id);
		Wizard.setInputStatus('sourceList', 'checking', 'Checking list...');
		
		var url = '../Outtake.servlet?ID='+App.getSessionId();
		url += '&cmd=CheckSourceList';
		url += '&listId='+list.id;
		Wizard.asyncJsonRequest(url, outtake.sourceListValidated);

	}
	
	
	outtake.sourceListValidated = function(response)
	{
		sourceListIsValid = false;
		Wizard.setInputStatus('sourceList');
		Wizard.setInputStatus('listRemainingQuantity');
		Wizard.setInputStatus('listNdConc');
		Wizard.setInputStatus('targetAmount');
		Wizard.setInputStatus('targetVolume');
		
		var frm = document.forms['reggie'];
		sourceList = response.list;
		
		var listType = sourceList.itemType;
		if (sourceList.subtype)
		{
			listType += ' (' + Strings.encodeTags(sourceList.subtype.name) + ')';
		}
		else if (sourceList.numDifferentSubtypes > 1)
		{
			Wizard.setInputStatus('listType', 'warning', 'The list have items of ' + sourceList.numDifferentSubtypes + ' different types');
		}
		
		Doc.element('listType').innerHTML = listType;
		Doc.element('listSize').innerHTML = sourceList.size;
		
		var remainingQuantity = sourceList.remainingQuantity;
		if (remainingQuantity)
		{
			Doc.element('listRemainingQuantity').innerHTML = 
				Reggie.formatNumber(remainingQuantity.min, ' µg (min), ', 2) +
				Reggie.formatNumber(remainingQuantity.max, ' µg (max)', 2);
			
			if (remainingQuantity.nulls > 0)
			{
				Wizard.setInputStatus('listRemainingQuantity', 'warning', remainingQuantity.nulls + ' items have unknown remaining quantity');
			}
		}
		var ndConc = sourceList.ndConc;
		if (ndConc)
		{
			Doc.element('listNdConc').innerHTML = 
				Reggie.formatNumber(ndConc.min, ' ng/µl (min), ', 2) +
				Reggie.formatNumber(ndConc.max, ' ng/µl (max)', 2);
			
			if (ndConc.nulls > 0)
			{
				Wizard.setInputStatus('listNdConc', 'warning', ndConc.nulls + ' items have unknown concentration');
			}
		}
		

		if (sourceList.size == 0)
		{
			Wizard.setInputStatus('sourceList', 'invalid', 'The list is empty');
			return;
		}
		else if (sourceList.itemType != 'EXTRACT')
		{
			Wizard.setInputStatus('sourceList', 'invalid', 'The list must contain extract items');
			return;
		}
		
		sourceListIsValid = true;
		if (sourceList.numDifferentSubtype > 0)
		{
			Wizard.setInputStatus('sourceList', 'warning', 'Items in the list are not of the same subtype');
		}
		else
		{
			Wizard.setInputStatus('sourceList', 'valid');
		}
		frm.targetAmount.focus();
		outtake.checkTargetAmountAndVolume();
	}
	
	outtake.nameOnChange = function()
	{
		nameIsValid = false;

		var frm = document.forms['reggie'];
		var name = frm.outtakeName.value;
			
		if (name == '')
		{
			Wizard.setInputStatus('outtakeName', 'invalid', 'Missing');
			return;
		}
			
		Wizard.setInputStatus('outtakeName', 'valid');
		nameIsValid = true; 
		Wizard.setNoConfirmOnFirstStep(false);
	}
	
	outtake.targetAmountOnChange = function()
	{
		Wizard.setInputStatus('targetAmount');
		targetAmountIsValid = false;

		var frm = document.forms['reggie'];
		var targetAmount = frm.targetAmount.value;
		
		if (targetAmount == '')
		{
			Wizard.setInputStatus('targetAmount', 'invalid', 'Missing');
			return;
		}
		if (parseFloat(targetAmount) <= 0)
		{
			Wizard.setInputStatus('targetAmount', 'invalid', 'Must be &gt;0');
			return;
		}
		
		Wizard.setNoConfirmOnFirstStep(false);
		Wizard.setInputStatus('targetAmount', 'valid');
		targetAmountIsValid = true;
		outtake.checkTargetAmountAndVolume();
	}

	outtake.targetVolumeOnChange = function()
	{
		Wizard.setInputStatus('targetVolume');
		targetVolumeIsValid = false;

		var frm = document.forms['reggie'];
		var targetVolume = frm.targetVolume.value;
		
		if (targetVolume == '')
		{
			Wizard.setInputStatus('targetVolume', 'invalid', 'Missing');
			return;
		}
		if (parseFloat(targetVolume) <= 0)
		{
			Wizard.setInputStatus('targetVolume', 'invalid', 'Must be &gt;0');
			return;
		}

		Wizard.setNoConfirmOnFirstStep(false);
		Wizard.setInputStatus('targetVolume', 'valid');
		targetVolumeIsValid = true;
		
		outtake.checkTargetAmountAndVolume();
	}
	
	outtake.checkTargetAmountAndVolume = function()
	{
		var frm = document.forms['reggie'];
		
		var targetAmount = parseFloat(frm.targetAmount.value);
		var targetVolume = parseFloat(frm.targetVolume.value);
		var targetConc = 1000 * targetAmount / targetVolume;
		
		if (!isNaN(targetConc))
		{
			Doc.element('targetConcentration').innerHTML = Reggie.formatNumber(targetConc, ' ng/µl', 2);
		}
		
		if (sourceList)
		{
			if (sourceList.remainingQuantity && sourceList.remainingQuantity.min < targetAmount)
			{
				Wizard.setInputStatus('targetAmount', 'warning', 'Some items in the list have less remaining quantity: '+ Reggie.formatNumber(sourceList.remainingQuantity.min, ' µg', 2));
			}
			
			if (sourceList.ndConc && sourceList.ndConc.min < targetConc)
			{
				Wizard.setInputStatus('targetVolume', 'warning', 'Some items in the list has too low concentration: '+ Reggie.formatNumber(sourceList.ndConc.min, ' ng/µl', 2));
			}
		}
	}
	
	outtake.validateStep1 = function(event)
	{
		var frm = document.forms['reggie'];
		if (!frm.sourceList.value) 
		{
			Wizard.setInputStatus('sourceList', 'invalid', 'A source list is required');
			event.preventDefault();
		}
		
		var valid = true;
		valid &= sourceListIsValid;
		valid &= nameIsValid;
		valid &= targetAmountIsValid;
		valid &= targetVolumeIsValid;
		
		if (!valid) event.preventDefault();
	}
	
	outtake.submit = function()
	{
		var frm = document.forms['reggie'];
		
		var submitInfo = {};
		
		submitInfo.sourceList = parseInt(frm.sourceList.value);
		submitInfo.outtakeName = frm.outtakeName.value;
		submitInfo.targetAmount = parseFloat(frm.targetAmount.value);
		submitInfo.targetVolume = parseFloat(frm.targetVolume.value);
		submitInfo.comments = frm.comments.value;

		var url = '../Outtake.servlet?ID='+App.getSessionId();
		url += '&cmd=DefineOuttake';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, outtake.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	outtake.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}
	
	return outtake;
}();

Doc.onLoad(Outtake.initPage);

